import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAzurermNatGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#name DataAzurermNatGateway#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#public_ip_address_ids DataAzurermNatGateway#public_ip_address_ids}
    */
    readonly publicIpAddressIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#public_ip_prefix_ids DataAzurermNatGateway#public_ip_prefix_ids}
    */
    readonly publicIpPrefixIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#resource_group_name DataAzurermNatGateway#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#timeouts DataAzurermNatGateway#timeouts}
    */
    readonly timeouts?: DataAzurermNatGatewayTimeouts;
}
export interface DataAzurermNatGatewayTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway#read DataAzurermNatGateway#read}
    */
    readonly read?: string;
}
export declare function dataAzurermNatGatewayTimeoutsToTerraform(struct?: DataAzurermNatGatewayTimeoutsOutputReference | DataAzurermNatGatewayTimeouts | cdktf.IResolvable): any;
export declare class DataAzurermNatGatewayTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): DataAzurermNatGatewayTimeouts | undefined;
    set internalValue(value: DataAzurermNatGatewayTimeouts | undefined);
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway azurerm_nat_gateway}
*/
export declare class DataAzurermNatGateway extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/azurerm/d/nat_gateway azurerm_nat_gateway} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAzurermNatGatewayConfig
    */
    constructor(scope: Construct, id: string, config: DataAzurermNatGatewayConfig);
    get id(): string;
    get idleTimeoutInMinutes(): number;
    get location(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _publicIpAddressIds?;
    get publicIpAddressIds(): string[];
    set publicIpAddressIds(value: string[]);
    resetPublicIpAddressIds(): void;
    get publicIpAddressIdsInput(): string[] | undefined;
    private _publicIpPrefixIds?;
    get publicIpPrefixIds(): string[];
    set publicIpPrefixIds(value: string[]);
    resetPublicIpPrefixIds(): void;
    get publicIpPrefixIdsInput(): string[] | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    get resourceGuid(): string;
    get skuName(): string;
    tags(key: string): string | cdktf.IResolvable;
    get zones(): string[];
    private _timeouts;
    get timeouts(): DataAzurermNatGatewayTimeoutsOutputReference;
    putTimeouts(value: DataAzurermNatGatewayTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): DataAzurermNatGatewayTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
